//--------------------------------------------------------------------------
//
//   Copyright (c) 2002, Colin Granville
//
//   All rights reserved.
//
//   Redistribution and use in source and binary forms, with or
//   without modification, are permitted provided that the following 
//   conditions are met:
//
//      * Redistributions of source code must retain the above copyright 
//        notice, this list of conditions and the following disclaimer.
//
//      * Redistributions in binary form must reproduce the above 
//        copyright notice, this list of conditions and the following 
//        disclaimer in the documentation and/or other materials 
//        provided with the distribution.
//
//      * The name Colin Granville may not be used to endorse or promote 
//        products derived from this software without specific prior 
//        written permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
//   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
//   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
//   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
//   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
//   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
//   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
//   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
//   OF THE POSSIBILITY OF SUCH DAMAGE.
//
//--------------------------------------------------------------------------

#ifndef GuiFlex_h
#define GuiFlex_h

#include <stddef.h>
#include "stl:bool.h"

class GuiFlexAnchor
{
  public:
    char* data;

    GuiFlexAnchor() : data(0) {}
};


class GuiFlex
{
  public:
    virtual         ~GuiFlex() {}  
    virtual bool    alloc(GuiFlexAnchor&,size_t n) = 0;
    virtual bool    free(GuiFlexAnchor&) = 0;
    virtual size_t  size(const GuiFlexAnchor&) const = 0;
    virtual bool    extend(GuiFlexAnchor&,size_t new_size) = 0;
    virtual bool    midExtend(GuiFlexAnchor&,size_t at,int by) = 0;
    virtual bool    reanchor(GuiFlexAnchor& to, GuiFlexAnchor& from) = 0;
    virtual bool    setBudge(bool on) = 0;
    virtual void    saveHeapInfo(char* filename) = 0; 
    virtual bool    compact() = 0;
    virtual bool    setDeferredCompaction(bool on) = 0;
    virtual size_t  availableMemory() = 0;
};

#endif
