//--------------------------------------------------------------------------
//
//   Copyright (c) 2002, Colin Granville
//
//   All rights reserved.
//
//   Redistribution and use in source and binary forms, with or
//   without modification, are permitted provided that the following 
//   conditions are met:
//
//      * Redistributions of source code must retain the above copyright 
//        notice, this list of conditions and the following disclaimer.
//
//      * Redistributions in binary form must reproduce the above 
//        copyright notice, this list of conditions and the following 
//        disclaimer in the documentation and/or other materials 
//        provided with the distribution.
//
//      * The name Colin Granville may not be used to endorse or promote 
//        products derived from this software without specific prior 
//        written permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
//   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
//   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
//   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
//   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
//   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
//   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
//   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
//   OF THE POSSIBILITY OF SUCH DAMAGE.
//
//--------------------------------------------------------------------------

#include "GuiWindow.h"
#include "swis.h"

GuiWindow::~GuiWindow() {}

//*************************************************************************

GuiObjectId GuiWindow::underlyingWindowId() const
{
  return id();
}

//*************************************************************************

bool GuiWindow::getState(GuiGetWindowStateBlock& ws) const
{
  ws.windowHandle=wimpHandle();
  return (_swix(Wimp_GetWindowState,_INR(1,2) | _OUTR(3,4),&ws,*(int*)"TASK"
                                   ,&ws.parent,&ws.linkFlags)==NULL);
}

//*************************************************************************

bool GuiWindow::update(GuiRedrawWindowBlock& rwb,int& more) const
{
  rwb.windowHandle=wimpHandle();
  return (_swix(Wimp_UpdateWindow,_IN(1) | _OUT(0),&rwb,&more)==NULL);
}

//*************************************************************************

bool GuiWindow::getOutline(GuiBBox& bounds) const
{
  struct
  {
    int window_handle;
    GuiBBox bounds;
  } blk;
  blk.window_handle=wimpHandle();

  if (_swix(Wimp_GetWindowOutline,_IN(1),&blk)==NULL)
  {
    bounds=blk.bounds;
    return 1;
  }

  return 0;
}

