//--------------------------------------------------------------------------
//
//   Copyright (c) 2002, Colin Granville
//
//   All rights reserved.
//
//   Redistribution and use in source and binary forms, with or
//   without modification, are permitted provided that the following 
//   conditions are met:
//
//      * Redistributions of source code must retain the above copyright 
//        notice, this list of conditions and the following disclaimer.
//
//      * Redistributions in binary form must reproduce the above 
//        copyright notice, this list of conditions and the following 
//        disclaimer in the documentation and/or other materials 
//        provided with the distribution.
//
//      * The name Colin Granville may not be used to endorse or promote 
//        products derived from this software without specific prior 
//        written permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
//   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
//   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
//   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
//   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
//   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
//   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
//   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
//   OF THE POSSIBILITY OF SUCH DAMAGE.
//
//--------------------------------------------------------------------------

#include "GuiWimp.h"
#include "GuiWimpMessage.h"

int GuiWimpMessageBase::send(int mess_code,int window_or_dest_task_handle,int icon_handle)
{
  hdr.yourRef=0;
  hdr.actionCode=mess_code;
  _swix(Wimp_SendMessage,_INR(0,3), GuiWimp_EUserMessage,this,
                                    window_or_dest_task_handle,icon_handle);
  return hdr.myRef;
}

//*************************************************************************
       
int GuiWimpMessageBase::sendRecorded(int mess_code,
                                  int window_or_dest_task_handle,int icon_handle)
{
  hdr.yourRef=0;
  hdr.actionCode=mess_code;
  _swix(Wimp_SendMessage,_INR(0,3), GuiWimp_EUserMessageRecorded,this,
                                    window_or_dest_task_handle,icon_handle);
  return hdr.myRef;
}

//*************************************************************************
       
int GuiWimpMessageBase::reply(int mess_code)
{
  hdr.yourRef=hdr.myRef;
  hdr.actionCode=mess_code;
  _swix(Wimp_SendMessage,_INR(0,2),GuiWimp_EUserMessage,this,hdr.sender);
  return hdr.myRef;
}

//*************************************************************************

int GuiWimpMessageBase::replyRecorded(int mess_code)
{
  hdr.yourRef=hdr.myRef;
  hdr.actionCode=mess_code;
  _swix(Wimp_SendMessage,_INR(0,2),GuiWimp_EUserMessageRecorded,this,hdr.sender);
  return hdr.myRef;
}

//*************************************************************************

int GuiWimpMessageBase::acknowledge()
{
  hdr.yourRef=hdr.myRef;
  _swix(Wimp_SendMessage,_INR(0,2),GuiWimp_EUserMessageAcknowledge,this,hdr.sender);
  return hdr.myRef;
}

//*************************************************************************

char* GuiWimpMessageBase::copyString(char* to,const char* from)
{
  char* begin=(char*)this;
  if (begin>to ||to-begin>=GuiWimpMessage::MAX_SIZE) return 0;
  char* end=begin+GuiWimpMessage::MAX_SIZE-1;
  for (;to<end;to++)
  {
    if (*from==0) break;
    *to=*from++;
  }
  hdr.size=((to-begin+4)&~3);
  *to=0;
  return to;
}


