//--------------------------------------------------------------------------
//
//   Copyright (c) 2002, Colin Granville
//
//   All rights reserved.
//
//   Redistribution and use in source and binary forms, with or
//   without modification, are permitted provided that the following 
//   conditions are met:
//
//      * Redistributions of source code must retain the above copyright 
//        notice, this list of conditions and the following disclaimer.
//
//      * Redistributions in binary form must reproduce the above 
//        copyright notice, this list of conditions and the following 
//        disclaimer in the documentation and/or other materials 
//        provided with the distribution.
//
//      * The name Colin Granville may not be used to endorse or promote 
//        products derived from this software without specific prior 
//        written permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
//   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
//   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
//   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
//   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
//   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
//   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
//   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
//   OF THE POSSIBILITY OF SUCH DAMAGE.
//
//--------------------------------------------------------------------------

#ifndef Printer_h
#define Printer_h

#include <string>
#include "DocViewChoices.h"

using namespace std;

class Document;

class PrintData
{ 
  public:
    PrintData();
    Document*      document;
    DocViewChoices viewChoices;

    int       copies;
    enum {IS_ALL               = (1<<0),
          IS_DOUBLE_SIDED      = (1<<1),
          IS_SIDE2             = (1<<2),
          IS_START_END         = (1<<3),
          IS_PAMPHLET          = (1<<4),
          IS_SECTION_SIZE      = (1<<5),
          IS_REVERSES_SHEETS   = (1<<6),
          IS_TURNS_PAPER_OVER  = (1<<7),
          IS_COLLATE           = (1<<8),
          IS_LANDSCAPE         = (1<<9),
          IS_USE_PAPER_MARGINS = (1<<10),
          IS_SCALE_TO_FIT      = (1<<11)
         };
    int       flags;
    int       from;
    int       to;
    int       start;
    int       end;
    int       sectionSize;
};

bool Printer_print(const PrintData&);

#endif
